-- try to get a script context, will be .nil, if script was not invoked by OOo
call bsfShowErrorMessage .true
xScriptContext = uno.getScriptContext()
if (xScriptContext<>.nil) then  -- invoked as a macro/via the dispatch interface
do
   xComponentContext = xScriptContext~getComponentContext
   xDesktop = xScriptContext~getDesktop
   xDocument = xScriptContext~getDocument
end
else  -- called from outside of OOo
do
   xComponentContext = UNO.connect()     -- get a connection
   service = "com.sun.star.frame.Desktop"
   sDesktop = xComponentContext~getServiceManager~XMultiServiceFactory~createInstance(service)
   xDesktop = sDesktop~XDesktop
end

-- this macro just works externally, called by rexxj or rexx
-- create DispatchHelper service and query its interface
xMultiServiceFactory = xComponentContext~getServiceManager~XMultiServiceFactory
sDispatchHelper = xMultiServiceFactory~createInstance("com.sun.star.frame.DispatchHelper")
xDispatchHelper = sDispatchHelper~XDispatchHelper

-- get dispatch provider interface of current Desktop
xDispatchProvider = xDesktop~XDispatchProvider

-- define Rexx dispatch target, library "wu_tools", script name "create_UNO_API_info.rex", location "user"
location   ="user"               -- case sensitive, other possible values: "share" (all users), "application"
libraryName="wu_tools"           -- case sensitive, name of the Rexx macro library
scriptName ="UNO_API_info.rex"   -- case sensitive, name of the Rexx script
langName   ="ooRexx"             -- case sensitive, OOo name of the scripting language
   --  build -- macroUrl--  string for the dispatcher
macroUrl="vnd.sun.star.script:"libraryName"."scriptName"?language="langName"&location="location



say "ooRexx: dispatching to 'create_UNO_API_info.rex' using an UNO object from the running program..."
   -- define one argument (an UNO object from the running program)
args=uno.CreateArray(.UNO~PROPERTYVALUE, 1)  -- array for argument
args[1] = uno.createProperty("arg1", sDispatchHelper)

   -- dispatch
res = xDispatchHelper~executeDispatch(xDispatchProvider, macroURL, "", 0, args)
-- say "ooRexx: res~result:" pp(res~result)   "res~state:" pp(res~state)
say "---"

say "ooRexx: dispatching to 'create_UNO_API_info.rex' using an UNO IDL string and rendering options..."
   -- define options
options = uno.CreateArray(.UNO~PROPERTYVALUE, 7)   /* define array for options   */
options[1] = uno.createProperty("NrOfLayers",           2)  -- 2="show two levels deep"
options[2] = uno.createProperty("View",                 1)  -- 1="view in writer"
options[3] = uno.createProperty("DocumentationSource",  1)  -- 1="use Internet" (base url)
options[4] = uno.createProperty("NumberingTypeLevel_1", 0)  -- 0="Alpha Uppercase"
options[5] = uno.createProperty("NumberingTypeLevel_2", 4)  -- 4="arabic"
options[6] = uno.createProperty("NumberingTypeLevel_3", 3)  -- 3="roman lower"
options[7] = uno.createProperty("FontName",             "DejaVu Sans Condensed")

   -- define two arguments
args=uno.createArray(.uno~propertyValue, 2)  -- we have two arguments
args[1]=uno.createProperty("arg1", "com.sun.star.frame.Desktop")  -- an UNO IDL string
args[2]=uno.createProperty("arg2", options)  -- the ptions for rendering

   -- dispatch
res = xDispatchHelper~executeDispatch(xDispatchProvider, macroURL, "", 0, args)
-- say "ooRexx: res~result:" pp(res~result)   "res~state:" pp(res~state)
say "---"

::requires UNO.CLS   -- get the UNO-support (includes BSF.CLS, i.e. Java-support)

/*
    ------------------------ Apache Version 2.0 license -------------------------
       Copyright (C) 2009 Rony G. Flatscher

       Licensed under the Apache License, Version 2.0 (the "License");
       you may not use this file except in compliance with the License.
       You may obtain a copy of the License at

           http://www.apache.org/licenses/LICENSE-2.0

       Unless required by applicable law or agreed to in writing, software
       distributed under the License is distributed on an "AS IS" BASIS,
       WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
       See the License for the specific language governing permissions and
       limitations under the License.
    -----------------------------------------------------------------------------
*/
